#module	
#deffunc fpsinit
	second0@ = gettime(6)
	milliseconds0@ = gettime(7)
	return

#deffunc fpscalc
	second1@ = gettime(6)
	milliseconds1@ = gettime(7)
	if second1@ = second0@{
		dmilliseconds@ = milliseconds1@ - milliseconds0@
	}
	else{
		dmilliseconds@ = 1000 + milliseconds1@ - milliseconds0@
	}
	fps@ = 1000.0 / dmilliseconds@
	second0@ = second1@
	milliseconds0@ = milliseconds1@
	return

#deffunc vectorplus array pvecr,array pvec0,array pvec1
	pvecr.0 = pvec0.0 + pvec1.0
	pvecr.1 = pvec0.1 + pvec1.1
	pvecr.2 = pvec0.2 + pvec1.2
	return

#deffunc vectorminus array mvecr,array mvec0,array mvec1
	mvecr.0 = mvec0.0 - mvec1.0
	mvecr.1 = mvec0.1 - mvec1.1
	mvecr.2 = mvec0.2 - mvec1.2
	return

#defcfunc vectordot array dvec0,array dvec1
	return dvec0.0 * dvec1.0 + dvec0.0 * dvec1.0 + dvec0.2 * dvec1.2

#deffunc vectorcross array cvecr,array cvec0,array cvec1
	cvecr.0 = cvec0.1 * cvec1.2 - cvec0.2 * cvec1.1
	cvecr.1 = cvec0.2 * cvec1.0 - cvec0.0 * cvec1.2
	cvecr.2 = cvec0.0 * cvec1.1 - cvec0.1 * cvec1.0
	return

#defcfunc vectorlength array lvec
	return sqrt(lvec.0 * lvec.0 + lvec.1 * lvec.1 + lvec.2 * lvec.2)

#deffunc vectornormalize array nvecr,array nvec0
	nveclength = sqrt(nvec0.0 * nvec0.0 + nvec0.1 * nvec0.1 + nvec0.2 * nvec0.2)
	nvecr.0 = nvec0.0 / nveclength
	nvecr.1 = nvec0.1 / nveclength
	nvecr.2 = nvec0.2 / nveclength
	return

#deffunc vectormultiplydbl array kvecr,double mutiplyk,array kvec0
	kvecr.0 = mutiplyk * kvec0.0
	kvecr.1 = mutiplyk * kvec0.1
	kvecr.2 = mutiplyk * kvec0.2
	return

#deffunc cameraangleroundxz double degstep
	x = campos@.0 - camtargetpos@.0
	y = campos@.1 - camtargetpos@.1
	z = campos@.2 - camtargetpos@.2
	r0 = sqrt(x * x + z * z)
	theta0 = atan(z,x)
	theta0 += degstep
	x = r0 * cos(theta0)
	z = r0 * sin(theta0)
	campos@.0 = camtargetpos@.0 + x
	campos@.2 = camtargetpos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameraangleroundy double degstep
	x = campos@.0 - camtargetpos@.0
	y = campos@.1 - camtargetpos@.1
	z = campos@.2 - camtargetpos@.2
	r = sqrt(x * x + y * y + z * z)
	r0 = sqrt(x * x + z * z)
	theta = atan(y,r0)
	phi = atan(z,x)
	xmax = r * cos(phi)
	zmax = r * sin(phi)
	theta += degstep
	;if theta >= 2.0 * M_PI : theta -= 2.0 * M_PI
	;r0 = r * cos(theta)
	y = r * sin(theta)
	x = xmax * cos(theta)
	z = zmax * cos(theta)
	campos@.0 = camtargetpos@.0 + x
	campos@.1 = camtargetpos@.1 + y
	campos@.2 = camtargetpos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameratargetroundxz double degstep
	x = camtargetpos@.0 - campos@.0
	y = camtargetpos@.1 - campos@.1
	z = camtargetpos@.2 - campos@.2
	
	r0 = sqrt(x * x + z * z)
	theta0 = atan(z,x)
	
	theta0 += degstep
	x = r0 * cos(theta0)
	z = r0 * sin(theta0)
	camtargetpos@.0 = campos@.0 + x
	camtargetpos@.2 = campos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameratargetroundy double degstep
	x = camtargetpos@.0 - campos@.0
	y = camtargetpos@.1 - campos@.1
	z = camtargetpos@.2 - campos@.2
	
	r0 = sqrt(x * x + z * z)
	phi = atan(z,x)
	r = sqrt(x * x + y * y + z * z)
	theta = atan(y,r0)
	theta += degstep
	xmax = r * cos(phi)
	zmax = r * sin(phi)
	y = r * sin(theta)
	x = xmax * cos(theta)
	z = zmax * cos(theta)
	camtargetpos@.0 = campos@.0 + x
	camtargetpos@.1 = campos@.1 + y
	camtargetpos@.2 = campos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameramovex double camerastep	
	campos@.0 += camerastep
	camtargetpos@.0 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return
	
#deffunc cameramovey double camerastep	
	campos@.1 += camerastep
	camtargetpos@.1 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameramovez double camerastep	
	campos@.2 += camerastep
	camtargetpos@.2 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameraposforward  double camerastep
	vectorminus camvec@,camtargetpos@,campos@
	camveclength = vectorlength(camvec@)
	vectormultiplydbl tempvec@,camerastep / camveclength,camvec@
	campos@.0 += tempvec@.0
	campos@.1 += tempvec@.1
	campos@.2 += tempvec@.2
	camtargetpos@.0 += tempvec@.0
	camtargetpos@.1 += tempvec@.1
	camtargetpos@.2 += tempvec@.2
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc camerag0backset
	campos@.0 = g0pos@.0 + 4.0 * cos(-g0dir@.1 + 2.5 * M_PI)
	campos@.1 = g0pos@.1 + 1.8
	campos@.2 = g0pos@.2 + 4.0 * sin(-g0dir@.1 + 2.5 * M_PI)
	camtargetpos@.0 = g0pos@.0
	camtargetpos@.1 = g0pos@.1 + 1.0
	camtargetpos@.2 = g0pos@.2
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#defcfunc dist2p double xd0,double yd0,double zd0,double xd1,double yd1,double zd1
	return sqrt((xd1 - xd0) * (xd1 - xd0) + (yd1 - yd0) * (yd1 - yd0) + (zd1 - zd0) * (zd1 - zd0))
	
#defcfunc dist2pxz double xd2,double zd2,double xd3,double zd3
	return sqrt((xd3 - xd2) * (xd3 - xd2) + (zd3 - zd2) * (zd3 - zd2))

#deffunc drawwall
	dfparam0 = absf(cos(0.017453 * double(rcnt@ \ 360)))
	matparamwalllight@.0 = limitf(dfparam0,0.2,1.0)
	cfunc64v obj3dmatset,objwalllight@,0,varptr64(matparamwalllight@)
	matparamwalllight@.1 = limitf(1.0 - dfparam0,0.2,1.0)
	cfunc64v obj3dmatset,objwalllight@,1,varptr64(matparamwalllight@)
	mattextransfer objwalllight@

	if campos@.2 < 0.0{
		cfunc64v obj3ddrawnm,objs1nwall@
		rotation@ = 0.0,0.0,0.0
		trans@ = 5.0,7.0,0.0
		cfunc64v obj3dsclrottrsset,objgear@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objgear@
		cfunc64v obj3dsclrottrsset,objgearpart@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objgearpart@
		trans@ = 3.0,5.0,0.0
		cfunc64v obj3dsclrottrsset,objlightpart@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objlightpart@
		cfunc64v obj3dsclrottrsset,objwalllight@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objwalllight@

		cfunc64v obj3ddrawnm,objentrance@
	}

	if campos@.0 < 10.0{
		cfunc64v obj3ddrawnm,objs1ewall@
		rotation@ = 0.0,0.5 * M_PI,0.0
		trans@ = 10.0,4.0,-8.0
		cfunc64v obj3dsclrottrsset,objgear@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objgear@
		cfunc64v obj3ddrawnm,objs1swall@
		cfunc64v obj3dsclrottrsset,objgearpart@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objgearpart@
		trans@ = 10.0,7.0,-5.0
		cfunc64v obj3dsclrottrsset,objlightpart@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objlightpart@
		cfunc64v obj3dsclrottrsset,objwalllight@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objwalllight@
	}

	if campos@.2 > -10.0{
		cfunc64v obj3ddrawnm,objs1swall@
		rotation@ = 0.0,M_PI,0.0
		trans@ = 9.0,6.0,-10.0
		cfunc64v obj3dsclrottrsset,objgear@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objgear@
		cfunc64v obj3dsclrottrsset,objgearpart@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objgearpart@
		trans@ = 2.0,4.0,-10.0
		cfunc64v obj3dsclrottrsset,objlightpart@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objlightpart@
		cfunc64v obj3dsclrottrsset,objwalllight@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objwalllight@
	}

	if campos@.0 > 0.0{
		cfunc64v obj3ddrawnm,objs1wwall@
		rotation@ = 0.0,-0.5 * M_PI,0.0
		trans@ = 0.0,8.0,-7.0
		cfunc64v obj3dsclrottrsset,objgear@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objgear@
		cfunc64v obj3dsclrottrsset,objgearpart@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objgearpart@
		trans@ = 0.0,1.0,-10.0
		cfunc64v obj3dsclrottrsset,objlightpart@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objlightpart@
		cfunc64v obj3dsclrottrsset,objwalllight@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objwalllight@

		cfunc64v obj3ddrawnm,objexit@
	}
	
	cfunc64v obj3ddrawnm,objwallhigh@
	cfunc64v obj3ddrawnm,objwalllow@
	
	cfunc64v obj3dframesetba,objgear@,gearcnt@
	return

#deffunc drawwalltex0
	cfunc64v setscissorrect,varptr64(irect1@)
	cfunc64v renderstart,50,10,10,1.0

	if istage@ <= 4{
		rendersprite texa@,384,104, 39.3846,2.0237, 0.0019,0.2207,0.0273,0.7148, 0,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	
		dfi =int(double(rcnt@ \ 300) * (512.0 / 300.0)) + 770
		if dfi >= 896 : dfi -= 512
		rendersprite texa@,dfi,360, 1.0,1.0, 0.4609,0.0059,0.5917,0.0645, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
		if dfi + 67 > 896 : dfi -= 512 : rendersprite texa@,dfi,360, 1.0,1.0, 0.4609,0.0059,0.5917,0.0645, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	
		dfi =int(double(rcnt@ \ 400) * (512.0 / 400.0)) + 450
		if dfi >= 896 : dfi -= 512
		rendersprite texa@,dfi,450, 1.0,1.0, 0.4648,0.0976,0.5917,0.1543, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
		if dfi + 65 > 896 : dfi -= 512 : rendersprite texa@,dfi,450, 1.0,1.0, 0.4648,0.0976,0.5917,0.1543, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	
		dfi =int(double(rcnt@ \ 350) * (512.0 / 350.0)) + 620
		if dfi >= 896 : dfi -= 512
		rendersprite texa@,dfi,535, 1.0,1.0, 0.4687,0.1777,0.6133,0.2305, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
		if dfi + 74 > 896 : dfi -= 512 : rendersprite texa@,dfi,535, 1.0,1.0, 0.4687,0.1777,0.6133,0.2305, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0

		dfi =int(double(rcnt@ \ 380) * (512.0 / 380.0)) + 400
		if dfi >= 896 : dfi -= 512
		rendersprite texa@,dfi,130, 1.0,1.0, 0.6230,0.0156,0.7695,0.0762, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
		if dfi + 75 > 896 : dfi -= 512 : rendersprite texa@,dfi,130, 1.0,1.0, 0.6230,0.0156,0.7695,0.0762, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0

		dfi =int(double(rcnt@ \ 420) * (512.0 / 420.0)) + 600
		if dfi >= 896 : dfi -= 512
		rendersprite texa@,dfi,200, 1.0,1.0, 0.6308,0.0957,0.7852,0.1585, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
		if dfi + 79 > 896 : dfi -= 512 : rendersprite texa@,dfi,200, 1.0,1.0, 0.6308,0.0957,0.7852,0.1585, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0

		dfi =int(double(rcnt@ \ 370) * (512.0 / 370.0)) + 500
		if dfi >= 896 : dfi -= 512
		rendersprite texa@,dfi,295, 1.0,1.0, 0.6425,0.1757,0.7813,0.2326, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
		if dfi + 71 > 896 : dfi -= 512 : rendersprite texa@,dfi,295, 1.0,1.0, 0.6425,0.1757,0.7813,0.2326, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	}
	else{
		rendersprite texa@,384,104, 2.0,32.0, 213.0 / 512.0,490.0 / 512.0,469.0 / 512.0,506.0 / 512.0, 0,rotrad@,rotcx0@,rotcy0@,projz@,1.0
		rendersprite texwallb1@,384,104 + (2 * rcnt@) \ 512, 1.0,1.0, 0.0,0.0,1.0,1.0, 1,rotrad@,rotcx0@,rotcy0@,projz@,0.4
		if rcnt@ \ 512 != 0 : rendersprite texwallb1@,384,104 + (2 * rcnt@) \ 512 - 512, 1.0,1.0, 0.0,0.0,1.0,1.0, 1,rotrad@,rotcx0@,rotcy0@,projz@,0.4
		rendersprite texwallb2@,384,104 + (3 * rcnt@) \ 512, 1.0,1.0, 0.0,0.0,1.0,1.0, 1,rotrad@,rotcx0@,rotcy0@,projz@,0.3
		if rcnt@ \ 512 != 0 : rendersprite texwallb2@,384,104 + (3 * rcnt@) \ 512 - 512, 1.0,1.0, 0.0,0.0,1.0,1.0, 1,rotrad@,rotcx0@,rotcy0@,projz@,0.3
	}
	nowbacki@ = cfunc64i(nowgetbackbufferindex)
	cfunc64v copyswapchaintotex,nowbacki@,texfromrender@,varptr64(ipos1@)
	cfunc64v setscissorrect,varptr64(irect0@)
	
	return

#deffunc drawwalltex1
	cfunc64v setscissorrect,varptr64(irect1@)
	cfunc64v renderstart,50,10,10,1.0
	
	rendersprite texa@,384,104, 39.3846,2.0237, 0.0019,0.2207,0.0273,0.7148, 0,rotrad@,rotcx0@,rotcy0@,projz@,1.0

	dfi =int(double(rcnt@ \ 1000) * (512.0 / 1000.0)) + 770
	if dfi >= 896 : dfi -= 512
	rendersprite texa@,dfi,260, 1.0,1.0, 0.4609,0.0059,0.5917,0.0645, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	if dfi + 67 > 896 : dfi -= 512 : rendersprite texa@,dfi,260, 1.0,1.0, 0.4609,0.0059,0.5917,0.0645, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	
	dfi =int(double(rcnt@ \ 1200) * (512.0 / 1200.0)) + 450
	if dfi >= 896 : dfi -= 512
	rendersprite texa@,dfi,150, 1.0,1.0, 0.4648,0.0976,0.5917,0.1543, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	if dfi + 65 > 896 : dfi -= 512 : rendersprite texa@,dfi,150, 1.0,1.0, 0.4648,0.0976,0.5917,0.1543, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	
	dfi =int(double(rcnt@ \ 1300) * (512.0 / 1300.0)) + 620
	if dfi >= 896 : dfi -= 512
	rendersprite texa@,dfi,235, 1.0,1.0, 0.4687,0.1777,0.6133,0.2305, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	if dfi + 74 > 896 : dfi -= 512 : rendersprite texa@,dfi,235, 1.0,1.0, 0.4687,0.1777,0.6133,0.2305, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0

	dfi =int(double(rcnt@ \ 1180) * (512.0 / 1180.0)) + 400
	if dfi >= 896 : dfi -= 512
	rendersprite texa@,dfi,110, 1.0,1.0, 0.6230,0.0156,0.7695,0.0762, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	if dfi + 75 > 896 : dfi -= 512 : rendersprite texa@,dfi,110, 1.0,1.0, 0.6230,0.0156,0.7695,0.0762, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0

	dfi =int(double(rcnt@ \ 1020) * (512.0 / 1020.0)) + 600
	if dfi >= 896 : dfi -= 512
	rendersprite texa@,dfi,150, 1.0,1.0, 0.6308,0.0957,0.7852,0.1585, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	if dfi + 79 > 896 : dfi -= 512 : rendersprite texa@,dfi,150, 1.0,1.0, 0.6308,0.0957,0.7852,0.1585, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0

	dfi =int(double(rcnt@ \ 1870) * (512.0 / 1870.0)) + 500
	if dfi >= 896 : dfi -= 512
	rendersprite texa@,dfi,200, 1.0,1.0, 0.6425,0.1757,0.7813,0.2326, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	if dfi + 71 > 896 : dfi -= 512 : rendersprite texa@,dfi,200, 1.0,1.0, 0.6425,0.1757,0.7813,0.2326, 1,rotrad@,rotcx0@,rotcy0@,projz@,1.0
	
	nowbacki@ = cfunc64i(nowgetbackbufferindex)
	cfunc64v copyswapchaintotex,nowbacki@,texfromrender@,varptr64(ipos1@)
	cfunc64v setscissorrect,varptr64(irect0@)
	
	return

#deffunc drawcube double dfbx,double dfby,double dfbz,int dfbkind
	switch dfbkind
	case 10
		rotation@ = 0.0,0.0,0.0
		trans@ = dfbx,dfby,dfbz
		cfunc64v obj3dsclrottrsset,objcubeleaf@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objcubeleaf@
	swbreak
	case 20
		rotation@ = 0.0,0.0,0.0
		trans@ = dfbx,dfby,dfbz
		cfunc64v obj3dsclrottrsset,objcubetree@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objcubetree@
	swbreak
	case 30
		rotation@ = 0.0,0.0,0.0
		trans@ = dfbx,dfby,dfbz
		cfunc64v obj3dsclrottrsset,objcubesand@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objcubesand@
	swbreak
	case 40
		rotation@ = 0.0,0.0,0.0
		trans@ = dfbx,dfby,dfbz
		cfunc64v obj3dsclrottrsset,objcuberock@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objcuberock@
	swbreak
	case 50
		rotation@ = 0.0,0.0,0.0
		trans@ = dfbx,dfby,dfbz
		cfunc64v obj3dsclrottrsset,objcubefix@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objcubefix@
	swbreak
	case 60
		rotation@ = 0.0,0.0,0.0
		trans@ = dfbx,dfby,dfbz
		cfunc64v obj3dsclrottrsset,objcubeadsorp@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3dtexchange,objcubeadsorp@,0,0,texupdown@
		cfunc64v obj3dtexchange,objcubeadsorp@,1,0,texmawari@
		cfunc64v obj3ddrawnm,objcubeadsorp@
	swbreak
	default
		dfi = dfbkind / 10 - 1
		dfj = dfbkind \ 10
		switch dfj
		case 1
			rotation@ = 0.0,0.0,0.5 * M_PI
			trans@ = dfbx + 0.5,dfby + 0.5,dfbz - 0.5
			cfunc64v obj3dsclrottrsset,objcubearrowleaf@ + dfi, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
			cfunc64v obj3ddrawnm,objcubearrowleaf@ + dfi
		swbreak
		case 2
			rotation@ = 0.0,0.0,-0.5 * M_PI
			trans@ = dfbx + 0.5,dfby + 0.5,dfbz - 0.5
			cfunc64v obj3dsclrottrsset,objcubearrowleaf@ + dfi, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
			cfunc64v obj3ddrawnm,objcubearrowleaf@ + dfi
		swbreak		
		case 3
			rotation@ = -0.5 * M_PI,0.0,0.0
			trans@ = dfbx + 0.5,dfby + 0.5,dfbz - 0.5
			cfunc64v obj3dsclrottrsset,objcubearrowleaf@ + dfi, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
			cfunc64v obj3ddrawnm,objcubearrowleaf@ + dfi
		swbreak
		case 4
			rotation@ = 0.5 * M_PI,0.0,0.0
			trans@ = dfbx + 0.5,dfby + 0.5,dfbz - 0.5
			cfunc64v obj3dsclrottrsset,objcubearrowleaf@ + dfi, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
			cfunc64v obj3ddrawnm,objcubearrowleaf@ + dfi
		swbreak
		case 5
			rotation@ = 0.0,0.0,M_PI
			trans@ = dfbx + 0.5,dfby + 0.5,dfbz - 0.5
			cfunc64v obj3dsclrottrsset,objcubearrowleaf@ + dfi, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
			cfunc64v obj3ddrawnm,objcubearrowleaf@ + dfi
		swbreak
		case 6
			rotation@ = 0.0,0.0,0.0
			trans@ = dfbx + 0.5,dfby + 0.5,dfbz - 0.5
			cfunc64v obj3dsclrottrsset,objcubearrowleaf@ + dfi, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
			cfunc64v obj3ddrawnm,objcubearrowleaf@ + dfi
		swbreak
		case 7
			rotation@ = 0.0,0.0,0.0
			trans@ = dfbx,dfby,dfbz
			cfunc64v obj3dsclrottrsset,objcubeadsorp@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
			switch dfi
			case 0
				cfunc64v obj3dtexchange,objcubeadsorp@,0,0,texleaf@
				cfunc64v obj3dtexchange,objcubeadsorp@,1,0,texleaf@
			swbreak
			case 1
				cfunc64v obj3dtexchange,objcubeadsorp@,0,0,texnenrin@
				cfunc64v obj3dtexchange,objcubeadsorp@,1,0,textreebark@
			swbreak
			case 2
				cfunc64v obj3dtexchange,objcubeadsorp@,0,0,texsand@
				cfunc64v obj3dtexchange,objcubeadsorp@,1,0,texsand@
			swbreak
			case 3
				cfunc64v obj3dtexchange,objcubeadsorp@,0,0,texrock@
				cfunc64v obj3dtexchange,objcubeadsorp@,1,0,texrock@
			swbreak
			swend
			cfunc64v obj3ddrawnm,objcubeadsorp@
		swbreak
		swend
	swbreak
	swend
	return

#deffunc drawsuujiw int suujix,int suujiy,int suujikind
	rendersprite@ mojitexmsg20white@,suujix,suujiy, 1.0,1.0,10.0 / 256.0 * double(suujikind),0.0,10.0 / 256.0 * double(suujikind + 1),20.0 / 256.0, 0,rotrad,rotcx0,rotcy0,projz,1.0
	return

#deffunc drawint int suujix0,int suujiy0,int suuji0
	dfstr = str(suuji0)
	repeat strlen(dfstr)
	dfi = peek(dfstr,cnt)
	switch dfi
	case 32
	swbreak
	case 45
		drawsuujiw suujix0 + 10 * cnt,suujiy0,11
	swbreak
	default
		drawsuujiw suujix0 + 10 * cnt,suujiy0,peek(dfstr,cnt) - 48
	swbreak
	swend
	loop
	return

#deffunc drawdouble int suujix0,int suujiy0,double suuji1
	dfstr = strf("%10.4f",suuji1)
	repeat strlen(dfstr)
	dfi = peek(dfstr,cnt)
	switch dfi
	case 32
	swbreak
	case 45
		drawsuujiw suujix0 + 10 * cnt,suujiy0,11
	swbreak
	case 46
		drawsuujiw suujix0 + 10 * cnt,suujiy0,10
	swbreak
	default
		drawsuujiw suujix0 + 10 * cnt,suujiy0,peek(dfstr,cnt) - 48
	swbreak
	swend
	loop
	return

#deffunc moveblks int dfblkkind,int dfblkdir
	dfresultadsorp = 0
	repeat blksnum@.dfblkkind
	spaceijk@.(blksposi@.dfblkkind.cnt).(blksposj@.dfblkkind.cnt).(blksposk@.dfblkkind.cnt) = 0
	loop
	repeat blksnum@.dfblkkind
	switch dfblkdir
	case 1
		blksposi@.dfblkkind.cnt += 1
	swbreak
	case 2
		blksposi@.dfblkkind.cnt -= 1
	swbreak
	case 3
		blksposj@.dfblkkind.cnt += 1
	swbreak
	case 4
		blksposj@.dfblkkind.cnt -= 1
	swbreak
	case 5
		blksposk@.dfblkkind.cnt += 1
	swbreak
	case 6
		blksposk@.dfblkkind.cnt -= 1
	swbreak
	swend
	loop
	repeat blksnum@.dfblkkind
	spaceijk@.(blksposi@.dfblkkind.cnt).(blksposj@.dfblkkind.cnt).(blksposk@.dfblkkind.cnt) = blksvalue@.dfblkkind.cnt
	loop

	if blksnum@.5 = 0 : return

	
	repeat blksnum@.dfblkkind
	if blksposi@.dfblkkind.cnt < 9{
		if spaceijk@.(blksposi@.dfblkkind.cnt + 1).(blksposj@.dfblkkind.cnt).(blksposk@.dfblkkind.cnt) = 60{
			dfresultadsorp = 1
			dfi = blksposi@.dfblkkind.cnt + 1
			dfj = blksposj@.dfblkkind.cnt
			dfk = blksposk@.dfblkkind.cnt
			
			spaceijk@.dfi.dfj.dfk = (dfblkkind + 1) * 10 + 7
			blksposi@.dfblkkind.(blksnum@.dfblkkind) = dfi
			blksposj@.dfblkkind.(blksnum@.dfblkkind) = dfj
			blksposk@.dfblkkind.(blksnum@.dfblkkind) = dfk
			blksvalue@.dfblkkind.(blksnum@.dfblkkind) = (dfblkkind + 1) * 10 + 7
			blksnum@.dfblkkind += 1

			repeat blksnum@.5
			if dfi != blksposi@.5.cnt : continue
			if dfj != blksposj@.5.cnt : continue
			if dfk != blksposk@.5.cnt : continue
			blksvalue@.5.cnt = -iprocess@
			break
			loop
		}
	}
	if blksposi@.dfblkkind.cnt > 0{
		if spaceijk@.(blksposi@.dfblkkind.cnt - 1).(blksposj@.dfblkkind.cnt).(blksposk@.dfblkkind.cnt) = 60{
			dfresultadsorp = 1
			dfi = blksposi@.dfblkkind.cnt - 1
			dfj = blksposj@.dfblkkind.cnt
			dfk = blksposk@.dfblkkind.cnt
			
			spaceijk@.dfi.dfj.dfk = (dfblkkind + 1) * 10 + 7
			blksposi@.dfblkkind.(blksnum@.dfblkkind) = dfi
			blksposj@.dfblkkind.(blksnum@.dfblkkind) = dfj
			blksposk@.dfblkkind.(blksnum@.dfblkkind) = dfk
			blksvalue@.dfblkkind.(blksnum@.dfblkkind) = (dfblkkind + 1) * 10 + 7
			blksnum@.dfblkkind += 1

			repeat blksnum@.5
			if dfi != blksposi@.5.cnt : continue
			if dfj != blksposj@.5.cnt : continue
			if dfk != blksposk@.5.cnt : continue
			blksvalue@.5.cnt = -iprocess@
			break
			loop
		}
	}
	if blksposj@.dfblkkind.cnt < 9{
		if spaceijk@.(blksposi@.dfblkkind.cnt).(blksposj@.dfblkkind.cnt + 1).(blksposk@.dfblkkind.cnt) = 60{
			dfresultadsorp = 1
			dfi = blksposi@.dfblkkind.cnt
			dfj = blksposj@.dfblkkind.cnt + 1
			dfk = blksposk@.dfblkkind.cnt

			spaceijk@.dfi.dfj.dfk = (dfblkkind + 1) * 10 + 7
			blksposi@.dfblkkind.(blksnum@.dfblkkind) = dfi
			blksposj@.dfblkkind.(blksnum@.dfblkkind) = dfj
			blksposk@.dfblkkind.(blksnum@.dfblkkind) = dfk
			blksvalue@.dfblkkind.(blksnum@.dfblkkind) = (dfblkkind + 1) * 10 + 7
			blksnum@.dfblkkind += 1

			repeat blksnum@.5
			if dfi != blksposi@.5.cnt : continue
			if dfj != blksposj@.5.cnt : continue
			if dfk != blksposk@.5.cnt : continue
			blksvalue@.5.cnt = -iprocess@
			break
			loop
		}
	}
	if blksposj@.dfblkkind.cnt > 0{
		if spaceijk@.(blksposi@.dfblkkind.cnt).(blksposj@.dfblkkind.cnt - 1).(blksposk@.dfblkkind.cnt) = 60{
			dfresultadsorp = 1
			dfi = blksposi@.dfblkkind.cnt
			dfj = blksposj@.dfblkkind.cnt - 1
			dfk = blksposk@.dfblkkind.cnt

			spaceijk@.dfi.dfj.dfk = (dfblkkind + 1) * 10 + 7
			blksposi@.dfblkkind.(blksnum@.dfblkkind) = dfi
			blksposj@.dfblkkind.(blksnum@.dfblkkind) = dfj
			blksposk@.dfblkkind.(blksnum@.dfblkkind) = dfk
			blksvalue@.dfblkkind.(blksnum@.dfblkkind) = (dfblkkind + 1) * 10 + 7
			blksnum@.dfblkkind += 1

			repeat blksnum@.5
			if dfi != blksposi@.5.cnt : continue
			if dfj != blksposj@.5.cnt : continue
			if dfk != blksposk@.5.cnt : continue
			blksvalue@.5.cnt = -iprocess@
			break
			loop
		}
	}
	loop
	
	
	return

#defcfunc movableblks int dfblkkind1,int dfblkdir1
	dfresult = 1
	repeat blksnum@.dfblkkind1
	switch dfblkdir1
	case 1
		if blksposi@.dfblkkind1.cnt = 9 : dfresult = 0 : swbreak
		dfj = spaceijk@.(blksposi@.dfblkkind1.cnt + 1).(blksposj@.dfblkkind1.cnt).(blksposk@.dfblkkind1.cnt)
		if dfj != 0{
			if dfj / 10 - 1 != dfblkkind1 : dfresult = 0
		}
		else{
			if blktocharaoverlap(blksposi@.dfblkkind1.cnt + 1,blksposj@.dfblkkind1.cnt,blksposk@.dfblkkind1.cnt) = 1 : dfresult = 0
		}
	swbreak
	case 2
		if blksposi@.dfblkkind1.cnt = 0 : dfresult = 0 : swbreak
		dfj = spaceijk@.(blksposi@.dfblkkind1.cnt - 1).(blksposj@.dfblkkind1.cnt).(blksposk@.dfblkkind1.cnt)
		if dfj != 0{
			if dfj / 10 - 1 != dfblkkind1 : dfresult = 0
		}
		else{
			if blktocharaoverlap(blksposi@.dfblkkind1.cnt - 1,blksposj@.dfblkkind1.cnt,blksposk@.dfblkkind1.cnt) = 1 : dfresult = 0
		}
	swbreak
	case 3
		if blksposj@.dfblkkind1.cnt = 9 : dfresult = 0 : swbreak
		dfj = spaceijk@.(blksposi@.dfblkkind1.cnt).(blksposj@.dfblkkind1.cnt + 1).(blksposk@.dfblkkind1.cnt)
		if dfj != 0{
			if dfj / 10 - 1 != dfblkkind1 : dfresult = 0
		}
		else{
			if blktocharaoverlap(blksposi@.dfblkkind1.cnt,blksposj@.dfblkkind1.cnt + 1,blksposk@.dfblkkind1.cnt) = 1 : dfresult = 0
		}
	swbreak
	case 4
		if blksposj@.dfblkkind1.cnt = 0 : dfresult = 0 : swbreak
		dfj = spaceijk@.(blksposi@.dfblkkind1.cnt).(blksposj@.dfblkkind1.cnt - 1).(blksposk@.dfblkkind1.cnt)
		if dfj != 0{
			if dfj / 10 - 1 != dfblkkind1 : dfresult = 0
		}
		else{
			if blktocharaoverlap(blksposi@.dfblkkind1.cnt,blksposj@.dfblkkind1.cnt - 1,blksposk@.dfblkkind1.cnt) = 1 : dfresult = 0
		}
	swbreak
	case 5
		if blksposk@.dfblkkind1.cnt = 9 : dfresult = 0 : swbreak
		dfj = spaceijk@.(blksposi@.dfblkkind1.cnt).(blksposj@.dfblkkind1.cnt).(blksposk@.dfblkkind1.cnt + 1)
		if dfj != 0{
			if dfj / 10 - 1 != dfblkkind1 : dfresult = 0
		}
		else{
			if blktocharaoverlap(blksposi@.dfblkkind1.cnt,blksposj@.dfblkkind1.cnt,blksposk@.dfblkkind1.cnt + 1) = 1 : dfresult = 0
		}
	swbreak
	case 6
		if blksposk@.dfblkkind1.cnt = 0 : dfresult = 0 : swbreak
		dfj = spaceijk@.(blksposi@.dfblkkind1.cnt).(blksposj@.dfblkkind1.cnt).(blksposk@.dfblkkind1.cnt - 1)
		if dfj != 0{
			if dfj / 10 - 1 != dfblkkind1 : dfresult = 0
		}
		else{
			if blktocharaoverlap(blksposi@.dfblkkind1.cnt,blksposj@.dfblkkind1.cnt,blksposk@.dfblkkind1.cnt - 1) = 1 : dfresult = 0
		}
	swbreak
	swend
	loop
	;logmes "dir:" + str(dfblkdir1) + "ijk:" + str(int(charapos@.0.jchara@)) + " " + str(9 + int(charapos@.2.jchara@)) + " " + str(int(charapos@.1.jchara@))
	if dfresult = 0 : return 0
	if int(charapos@.1.jchara@) = 10 : return 1
	switch dfblkdir1
	case 1
		if spaceijk@.(int(charapos@.0.jchara@) + 1).(9 + int(charapos@.2.jchara@)).(int(charapos@.1.jchara@)) != 0 : dfresult = 0
	swbreak
	case 2
		if spaceijk@.(int(charapos@.0.jchara@) - 1).(9 + int(charapos@.2.jchara@)).(int(charapos@.1.jchara@)) != 0 : dfresult = 0
	swbreak
	case 3
		if spaceijk@.(int(charapos@.0.jchara@)).(10 + int(charapos@.2.jchara@)).(int(charapos@.1.jchara@)) != 0 : dfresult = 0
	swbreak
	case 4
		if spaceijk@.(int(charapos@.0.jchara@)).(8 + int(charapos@.2.jchara@)).(int(charapos@.1.jchara@)) != 0 : dfresult = 0
	swbreak
	case 5
		if int(charapos@.1.jchara@) = 9 : return 1
		if spaceijk@.(int(charapos@.0.jchara@)).(9 + int(charapos@.2.jchara@)).(int(charapos@.1.jchara@) + 1) != 0 : dfresult = 0
	swbreak
	swend
	return dfresult

#defcfunc blktocharaoverlap int dfi1,int dfj1,int dfk1
	dfresult1 = 0
	repeat 4
	if cnt = jchara@ : continue
	if dfi1 != int(charapos@.0.cnt) : continue
	if dfj1 != 9 + int(charapos@.2.cnt) : continue
	if dfk1 != int(charapos@.1.cnt) : continue
	dfresult1 = 1
	loop
	return dfresult1
	
#deffunc drawblks
	repeat 4
	dfbcnt = cnt
		repeat blksnum@.dfbcnt
		if movingblkcnt@ != 0{
			if charaonblks@.jchara@ = dfbcnt{
				switch movingblkdir@
				case 1
					drawcube double(blksposi@.dfbcnt.cnt) + double(60 - movingblkcnt@) * 0.016666,double(blksposk@.dfbcnt.cnt),-9.0 + double(blksposj@.dfbcnt.cnt),blksvalue@.dfbcnt.cnt
				swbreak
				case 2
					drawcube double(blksposi@.dfbcnt.cnt) - double(60 - movingblkcnt@) * 0.016666,double(blksposk@.dfbcnt.cnt),-9.0 + double(blksposj@.dfbcnt.cnt),blksvalue@.dfbcnt.cnt
				swbreak
				case 3
					drawcube double(blksposi@.dfbcnt.cnt),double(blksposk@.dfbcnt.cnt),-9.0 + double(blksposj@.dfbcnt.cnt) + double(60 - movingblkcnt@) * 0.016666,blksvalue@.dfbcnt.cnt
				swbreak
				case 4
					drawcube double(blksposi@.dfbcnt.cnt),double(blksposk@.dfbcnt.cnt),-9.0 + double(blksposj@.dfbcnt.cnt) - double(60 - movingblkcnt@) * 0.016666,blksvalue@.dfbcnt.cnt
				swbreak
				case 5
					drawcube double(blksposi@.dfbcnt.cnt),double(blksposk@.dfbcnt.cnt) + double(60 - movingblkcnt@) * 0.016666,-9.0 + double(blksposj@.dfbcnt.cnt),blksvalue@.dfbcnt.cnt
				swbreak
				case 6
					drawcube double(blksposi@.dfbcnt.cnt),double(blksposk@.dfbcnt.cnt) - double(60 - movingblkcnt@) * 0.016666,-9.0 + double(blksposj@.dfbcnt.cnt),blksvalue@.dfbcnt.cnt
				swbreak
				swend
			}
			else{
				drawcube double(blksposi@.dfbcnt.cnt),double(blksposk@.dfbcnt.cnt),-9.0 + double(blksposj@.dfbcnt.cnt),blksvalue@.dfbcnt.cnt
			}
			
		}
		else{
			drawcube double(blksposi@.dfbcnt.cnt),double(blksposk@.dfbcnt.cnt),-9.0 + double(blksposj@.dfbcnt.cnt),blksvalue@.dfbcnt.cnt
		}
		loop
	loop
	repeat blksnum@.4
	drawcube double(blksposi@.4.cnt),double(blksposk@.4.cnt),-9.0 + double(blksposj@.4.cnt),50
	loop
	repeat blksnum@.5
	if blksvalue@.5.cnt = 60 : drawcube double(blksposi@.5.cnt),double(blksposk@.5.cnt),-9.0 + double(blksposj@.5.cnt),60
	loop
	if movingblkcnt@ != 0{
		rotation@ = 0.0,0.0,0.0
		trans@.0 = charapos@.0.jchara@
		trans@.1 = charapos@.1.jchara@
		trans@.2 = charapos@.2.jchara@
		scale@.0 = double(rcnt@ \ 40) * 0.001 + 1.0
		scale@.1 = double(rcnt@ \ 40) * 0.001 + 1.5
		scale@.2 = double(rcnt@ \ 40) * 0.001 + 1.0
		cfunc64v obj3dsclrottrsset,objyellowlight@, varptr64(scale@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objyellowlight@
	}
	return
#deffunc lclickmovablematset
	repeat 10
	dfj = cnt
		repeat 10
		lclickmatrix@.cnt.dfj = -1
		loop
	loop

	repeat 4
	if (blkundercharas@.cnt != jchara@)and(blkundercharas@.cnt >= 0) : continue
	dfbcnt = cnt
	if blksposk@.dfbcnt.0 != int(charapos@.1.jchara@) - 1 : continue
		repeat blksnum@.dfbcnt
		lclickmatrix@.(blksposi@.dfbcnt.cnt).(blksposj@.dfbcnt.cnt) = 0
		loop
	loop
	
	repeat blksnum@.4
	dfcnt = cnt
	if blksposk@.4.dfcnt = int(charapos@.1.jchara@) - 1{
		dfresult = 0
		repeat 4
		if cnt = jchara@ : continue
		if blksposi@.4.dfcnt != int(charapos@.0.cnt) : continue
		if blksposj@.4.dfcnt != 9 + int(charapos@.2.cnt) : continue
		if blksposk@.4.dfcnt != int(charapos@.1.cnt) - 1 : continue
		dfresult = 1
		loop
		if dfresult = 0 : lclickmatrix@.(blksposi@.4.dfcnt).(blksposj@.4.dfcnt) = 0
	}
	loop
	
	repeat 4
	dfbcnt = cnt
	if blksposk@.dfbcnt.0 = int(charapos@.1.jchara@){
		repeat blksnum@.dfbcnt
		lclickmatrix@.(blksposi@.dfbcnt.cnt).(blksposj@.dfbcnt.cnt) = -1
		loop
	}
	loop
	repeat blksnum@.4
	if blksposk@.4.cnt = int(charapos@.1.jchara@) : lclickmatrix@.(blksposi@.4.cnt).(blksposj@.4.cnt) = -1
	loop
	repeat blksnum@.5
	if blksvalue@.5.cnt = 60{
		if blksposk@.5.cnt = int(charapos@.1.jchara@) : lclickmatrix@.(blksposi@.5.cnt).(blksposj@.5.cnt) = -1
	}
	loop
	
	lclickmatrix@.(int(charapos@.0.jchara@)).(9 + int(charapos@.2.jchara@)) = 1
	
	dfresult = 0
	checknum = 1
	repeat
		repeat 10
		dfj = cnt
			repeat 10
			if lclickmatrix@.cnt.dfj = checknum{
				if cnt != 0{
					if lclickmatrix@.(cnt - 1).dfj = 0 : lclickmatrix@.(cnt - 1).dfj = checknum + 1 : dfresult++
				}
				if cnt != 9{
					if lclickmatrix@.(cnt + 1).dfj = 0 : lclickmatrix@.(cnt + 1).dfj = checknum + 1 : dfresult++
				}
				if dfj != 0{
					if lclickmatrix@.cnt.(dfj - 1) = 0 : lclickmatrix@.cnt.(dfj - 1) = checknum + 1 : dfresult++
				}
				if dfj != 9{
					if lclickmatrix@.cnt.(dfj + 1) = 0 : lclickmatrix@.cnt.(dfj + 1) = checknum + 1 : dfresult++
				}
			}
			loop
		loop
		if dfresult = 0 : break
		checknum++
		dfresult = 0
	loop
	
	;repeat 10
	;dfj = 9 - cnt
	;dfstr = ""
	;	repeat 10
	;	dfstr += strf("%2d",lclickmatrix@.cnt.dfj) + ";"
	;	loop
	;logmes dfstr
	;loop
	return

#deffunc drawblklight1
	scale@.0 = 1.0
	scale@.1 = 0.1 * sin(double(rcnt@) * 0.104719) + 0.4
	scale@.2 = 1.0
	rotation@ = 0.0,0.0,0.0
	repeat 10
	dfj = cnt
		repeat 10
		if lclickmatrix@.cnt.dfj > 0{
			trans@.0 = double(cnt)
			trans@.1 = charapos@.1.jchara@
			trans@.2 = -9.0 + double(dfj)
			cfunc64v obj3dsclrottrsset,objblklight@, varptr64(scale@), varptr64(rotation@), varptr64(trans@)
			cfunc64v obj3ddrawnm,objblklight@
		}
		loop
	loop
	return
	
#deffunc drawselectring1
	datamouse@.0 = mousex
	datamouse@.1 = mousey
	cfunc64v posfromscreentoworld,varptr64(datamouse@),varptr64(nearzworld@),varptr64(farzworld@)
	vectorminus vec0@,farzworld@,nearzworld@
	vectornormalize vec1@,vec0@
	;dfk = (double(blksposk@.(charaonblks@.jchara@).0 + 1) - nearzworld@.1) / vec1@.1
	dfk = (charapos@.1.jchara@ - nearzworld@.1) / vec1@.1
	dfx = nearzworld@.0 + dfk * vec1@.0
	dfz = nearzworld@.2 + dfk * vec1@.2
	dfi = int(dfx)
	dfj = 9 + int(dfz)
	;dfk = blksposk@.(charaonblks@.jchara@).0
	dfk = int(charapos@.1.jchara@ - 1.0)

	if (dfi < 0)or(dfi > 9)or(dfj < 0)or(dfj > 9) : charamovable = 0 : return
	if lclickmatrix@.dfi.dfj > 0{
		charamovable = 1
	}
	else{
		charamovable = 0
		return
	}
	rotation@ = 0.0,0.0,0.0
	repeat 5
	cfunc64v obj3dbrendmodeset,objselectring@, 3, double(5 - cnt) * 0.12
	trans@ = double(dfi) + 0.5,double(dfk + 1) + double(cnt) * 0.1 * double(rcnt@ \ 45) * 0.01,double(dfj - 9) - 0.5
	cfunc64v obj3dsclrottrsset,objselectring@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objselectring@
	loop
	return
	
#deffunc setmotionkind int dfc,int dfm
	charamotion@.dfc = dfm
	switch charamotion@.dfc
	case 0
		charaframe@.dfc = 2
	swbreak
	case 1
		charaframe@.dfc = 182
	swbreak
	case 2
		charaframe@.dfc = 242
	swbreak
	swend
	return

#deffunc setnewframe int dfc1
	switch charamotion@.dfc1
	case 0
		charaframe@.dfc1++
		if charaframe@.dfc1 = 182 : charaframe@.dfc1 = 2
	swbreak
	case 1
		charaframe@.dfc1++
		if charaframe@.dfc1 = 242 : charaframe@.dfc1 = 182
	swbreak
	case 2
		charaframe@.dfc1++
		if charaframe@.dfc1 = 302 : charaframe@.dfc1 = 301
	swbreak
	case 3
		charaframe@.dfc1++
		if charaframe@.dfc1 = 302 : charaframe@.dfc1 = 242
	swbreak
	swend
	cfunc64v obj3dframesetba,dfc1, charaframe@.dfc1
	return

#deffunc inutasetnewframe
	switch inutamotion@
	case 0
		inutaframe@++
		if inutaframe@ = 243 : inutaframe@ = 2
	swbreak
	swend
	cfunc64v obj3dframesetba,objinuta@,inutaframe@
	return

#deffunc kentasetnewframe
	switch kentamotion@
	case 0
		kentaframe@++
		if kentaframe@ = 243 : kentaframe@ = 2
	swbreak
	swend
	cfunc64v obj3dframesetba,objkenta@,kentaframe@
	return
	
#deffunc setwalkmatrix
	repeat 10
	dfj = cnt
		repeat 10
		walkmatrix@.cnt.dfj = limit(lclickmatrix@.cnt.dfj,-1,0)
		loop
	loop
	return
#deffunc setwalkmatrixk9
	repeat 10
	dfj = cnt
		repeat 10
		if spaceijk@.cnt.dfj.9 = 0{
			walkmatrix@.cnt.dfj = -1
		}
		else{
			walkmatrix@.cnt.dfj = 0
		}
		loop
	loop
	return

#deffunc walkmatrixpathcalc
	dfresult = 0
	checknum = 1
	repeat
		repeat 10
		dfj = cnt
			repeat 10
			if walkmatrix@.cnt.dfj = checknum{
				if cnt != 0{
					if walkmatrix@.(cnt - 1).dfj = 0 : walkmatrix@.(cnt - 1).dfj = checknum + 1 : dfresult++
				}
				if cnt != 9{
					if walkmatrix@.(cnt + 1).dfj = 0 : walkmatrix@.(cnt + 1).dfj = checknum + 1 : dfresult++
				}
				if dfj != 0{
					if walkmatrix@.cnt.(dfj - 1) = 0 : walkmatrix@.cnt.(dfj - 1) = checknum + 1 : dfresult++
				}
				if dfj != 9{
					if walkmatrix@.cnt.(dfj + 1) = 0 : walkmatrix@.cnt.(dfj + 1) = checknum + 1 : dfresult++
				}
			}
			loop
		loop
		if dfresult = 0 : break
		checknum++
		dfresult = 0
	loop
	
	;repeat 10
	;dfj = 9 - cnt
	;dfstr = ""
	;	repeat 10
	;	dfstr += strf("%2d",walkmatrix@.cnt.dfj) + ";"
	;	loop
	;logmes dfstr
	;loop
	return
	
#deffunc nextijdirset
	if nowi@ > 0{
		if walkmatrix@.(nowi@ - 1).nowj@ = walkmatrix@.nowi@.nowj@ - 1{
			nexti@ = nowi@ - 1
			nextj@ = nowj@
			charadir@.1.jchara@ = 0.5 * M_PI
			return
		}
	}
	if nowi@ < 9{
		if walkmatrix@.(nowi@ + 1).nowj@ = walkmatrix@.nowi@.nowj@ - 1{
			nexti@ = nowi@ + 1
			nextj@ = nowj@
			charadir@.1.jchara@ = -0.5 * M_PI
			return
		}
	}
	if nowj@ > 0{
		if walkmatrix@.nowi@.(nowj@ - 1) = walkmatrix@.nowi@.nowj@ - 1{
			nexti@ = nowi@
			nextj@ = nowj@ - 1
			charadir@.1.jchara@ = 0.0
			return
		}
	}
	if nowj@ < 9{
		if walkmatrix@.nowi@.(nowj@ + 1) = walkmatrix@.nowi@.nowj@ - 1{
			nexti@ = nowi@
			nextj@ = nowj@ + 1
			charadir@.1.jchara@ = M_PI
			return
		}
	}
	nexti@ = -1
	nextj@ = -1
	return

#deffunc posforwardxz int dfc2,double dfr
	charapos@.0.dfc2 += dfr * cos(-charadir@.1.dfc2 + 1.5 * M_PI)
	charapos@.2.dfc2 += dfr * sin(-charadir@.1.dfc2 + 1.5 * M_PI)
	cfunc64v obj3dsclrottrsset,dfc2, varptr64(scale1@), varptr64(charadir@.0.dfc2), varptr64(charapos@.0.dfc2)
	return

#deffunc charachange int dfc3
	if charamoving@ != 0 : return
	jchara@ = dfc3
	lclickmovablematclac@ = 0
	if (absf(charapos@.0.jchara@ -  0.5) < 0.01)and(absf(charapos@.1.jchara@ - 1.0) < 0.01)and(absf(charapos@.2.jchara@ + 6.5) < 0.01){
		goaloryet@ = 1
	}
	else{
		goaloryet@ = 0
	}
	return

#deffunc screenplaceset
	dfi = rnd(2)
	if dfi = 1{
		dfj = screenplace@.0
		screenplace@.0 = screenplace@.1
		screenplace@.1 = dfj
	}
	dfi = rnd(2)
	if dfi = 1{
		dfj = screenplace@.0
		screenplace@.0 = screenplace@.2
		screenplace@.2 = dfj
	}
	dfi = rnd(2)
	if dfi = 1{
		dfj = screenplace@.0
		screenplace@.0 = screenplace@.3
		screenplace@.3 = dfj
	}
	return

#deffunc charainfodraw
	if jchara@ != -1 : rendersprite texrotcircle@,0,20 + jchara@ * 130,1.0,1.0,0.0,0.0,120.0 / 256.0,120.0 / 256.0,0,M_PI * double(rcnt@ \ 360) / 180.0,60,60,projz@,0.7
	
	repeat 4
	datamouse@.0 = 60
	datamouse@.1 = cnt * 130 + 80
	cfunc64v posfromscreentoworld,varptr64(datamouse@),varptr64(nearzworld@),varptr64(farzworld@)
	vectorminus vec0@,farzworld@,nearzworld@
	vectornormalize vec1@,vec0@
	dfx = charapos@.0.cnt
	dfy = charapos@.1.cnt
	dfz = charapos@.2.cnt
	charapos@.0.cnt = nearzworld@.0 + vec1@.0
	charapos@.1.cnt = nearzworld@.1 + vec1@.1
	charapos@.2.cnt = nearzworld@.2 + vec1@.2
	scale@ = 0.15,0.15,0.15
	cfunc64v obj3dsclrottrsset,cnt, varptr64(scale@), varptr64(charadir@.0.cnt), varptr64(charapos@.0.cnt)
	cfunc64v obj3ddrawba,cnt
	scale@ = 0.1,0.1,0.1
	rotation@ = 0.0,0.0,0.0
	trans@ = charapos@.0.cnt - 0.05,charapos@.1.cnt - 0.1,charapos@.2.cnt + 0.05
	if charaonblks@.cnt < 0{
		cfunc64v obj3dsclrottrsset,objcubegoal@, varptr64(scale@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objcubegoal@
	}
	else{
		cfunc64v obj3dsclrottrsset,objcubeleaf@ + charaonblks@.cnt, varptr64(scale@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objcubeleaf@ + charaonblks@.cnt
	}
	
	charapos@.0.cnt = dfx
	charapos@.1.cnt = dfy
	charapos@.2.cnt = dfz
	cfunc64v obj3dsclrottrsset,cnt, varptr64(scale1@), varptr64(charadir@.0.cnt), varptr64(charapos@.0.cnt)
	loop

	if goaloryet@ = 1{
		rendersprite texa@,0,80 + jchara@ * 130,1.0,1.0,2.0 / 512.0,441.0 / 512.0,122.0 / 512.0,500.0 / 512.0, 3,rotrad@,rotcx0@,rotcy0@,projz@,0.9
	}
	return

#deffunc getmouseregion
	if mousex < 120{
		if mousey <= 535 : mouseregion@ = 0 : else : mouseregion@ = 1
	}
	else{
		if mousex > 1165{
			mouseregion@ = 2
		}
		else{
			mouseregion@ = 3
		}
	}
	if charamoving@ = 5 : mouseregion@ = -1
	return

#deffunc getmouseregionstage
	if mousex < 100{
		if mousey <= 680 : mouseregion@ = -1 : else : mouseregion@ = -2
	}
	else{
		dfi = (mousex - 100) / 400
		dfj = mousey / 240
		mouseregion@ = dfj * 3 + dfi
	}
	return

#deffunc getmouseregiontitle
	mouseregion@ = -1
	if (mousex > 522)and(mousex < 758){
		if (mousey >= 450)and(mousey <= 640){
			mouseregion@ = (mousey - 450) / 64
		}
	}
	return
	
#deffunc stagefileread int dfstage
	repeat 10
	dfi = cnt
		repeat 10
		dfj = cnt
			repeat 10
			spaceijk@.dfi.dfj.cnt = 0
			loop
		loop
	loop
	repeat 6
	jblk@.cnt = 0
	loop

	dfstagestr = "stage" + str(dfstage) + ".txt"
	
	noteload dfstagestr
	iline@ = 0
	repeat 10
	dfk = 9 - cnt
	noteget fileline@,iline@
	;logmes fileline
	split fileline@,";",forloadstr@
	if forloadstr@.1 = "a"{
		repeat 10
		dfj = cnt
		noteget fileline@,dfj + iline@ + 1
		split fileline@,";",forloadstr@
			repeat 10
			dfi = int(forloadstr@.cnt)
			spaceijk@.cnt.(9 - dfj).dfk = dfi
			dfn = dfi / 10 - 1
			if dfn != -1{
				blksposi@.dfn.(jblk@.dfn) = cnt
				blksposj@.dfn.(jblk@.dfn) = 9 - dfj
				blksposk@.dfn.(jblk@.dfn) = dfk
				blksvalue@.dfn.(jblk@.dfn) = dfi
				jblk@.dfn += 1
			}
			loop
		loop
		iline@ += 11
	}
	else{
		iline@++
	}
	loop
	repeat 6
	blksnum@.cnt = jblk@.cnt
	;logmes blksnum(cnt)
	loop
	return

#deffunc lowtreedraw double dftreex,double dftreey,double dftreez,double dftreeroty
	dfx = 0.01 * sin(double(rcnt@ \ 180) * 0.035)
	dfz = 0.01 * sin(double(rcnt@ \ 240) * 0.026)
	rotation@ = 0.523 + dfx,dftreeroty,dfz
	trans@ = dftreex,dftreey,dftreez
	cfunc64v obj3dsclrottrsset,objbranch@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objbranch@

	rotation@ = -0.523 + dfx,dftreeroty,dfz
	trans@ = dftreex,dftreey,dftreez
	cfunc64v obj3dsclrottrsset,objbranch@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objbranch@

	rotation@ = dfx,dftreeroty,0.523 + dfz
	trans@ = dftreex,dftreey,dftreez
	cfunc64v obj3dsclrottrsset,objbranch@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objbranch@

	rotation@ = dfx,dftreeroty,-0.523 + dfz
	trans@ = dftreex,dftreey,dftreez
	cfunc64v obj3dsclrottrsset,objbranch@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objbranch@
	return

#deffunc hightreedraw double dftreex1,double dftreey1,double dftreez1,double dftreeroty1
	rotation@ = 0.0,dftreeroty1,0.0
	trans@ = dftreex1,dftreey1,dftreez1
	cfunc64v obj3dsclrottrsset,objtrunk0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objtrunk0@

	dfx = 0.01 * sin(double(rcnt@ \ 280) * 0.02243)
	dfz = 0.008 * sin(double(rcnt@ \ 300) * 0.02094)
	rotation@ = 0.249 + dfx,dftreeroty1,dfz
	trans@ = dftreex1,dftreey1 + 1.6,dftreez1
	cfunc64v obj3dsclrottrsset,objbranch2a@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objbranch2a@

	dfx = 0.005 * sin(double(rcnt@ \ 180) * 0.035)
	dfz = 0.005 * sin(double(rcnt@ \ 240) * 0.026)
	rotation@ = -0.523 + dfx,dftreeroty1,dfz - 0.449
	trans@ = dftreex1,dftreey1 + 1.6,dftreez1
	cfunc64v obj3dsclrottrsset,objbranch2b@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objbranch2b@

	dfx = 0.004 * sin(double(rcnt@ \ 160) * 0.03927)
	dfz = 0.003 * sin(double(rcnt@ \ 200) * 0.03141)
	rotation@ = dfx,dftreeroty1,dfz + 0.623
	trans@ = dftreex1,dftreey1 + 1.6,dftreez1
	cfunc64v obj3dsclrottrsset,objbranch2c@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objbranch2c@

	return

#deffunc grassdraw double dfgrassx,double dfgrassz,double dfgrassscale,int foffset
	trans@ = dfgrassx,-0.05,dfgrassz
	scale@ = dfgrassscale,dfgrassscale,dfgrassscale
	rotation@ =0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objgrass@, varptr64(scale@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objgrass@, (rcnt@ + foffset) \ 161 + 2
	cfunc64v obj3ddrawba,objgrass@
	return

#deffunc grassparamset
	randomize 0
	dfi = 0
	repeat
	if dfi = 10 : break
	grassx@.dfi = 0.5 * double(rnd(41)) - 10.0
	grassz@.dfi = 0.5 * double(rnd(41)) - 10.0
	dfj = grassregion(grassx@.dfi,grassz@.dfi)
	if dfj = 0 : continue
	grassscale@.cnt = double(rnd(5) - 2) / 10.0 + 1.0
	grassframe@.cnt = rnd(50)
	dfi++
	loop
	return

#defcfunc grassregion double dfgrassx1,double dfgrassz1
	if (dfgrassx1 < -6.0)or(dfgrassx1 > 6.0) : return 1
	if (dfgrassz1 < -5.0)or(dfgrassz1 > 6.0) : return 1
	if (dfgrassz1 > -dfgrassx1 + 8.0)and(dfgrassx1 > 0.0)and(dfgrassz1 > 0.0) : return 1
	if (dfgrassz1 > dfgrassx1 + 8.0)and(dfgrassx1 < 0.0)and(dfgrassz1 > 0.0) : return 1
	if (dfgrassz1 < -dfgrassx1 - 6.0)and(dfgrassx1 < 0.0)and(dfgrassz1 < 0.0) : return 1
	if (dfgrassz1 < dfgrassx1 - 6.0)and(dfgrassx1 > 0.0)and(dfgrassz1 < 0.0) : return 1
	return 0
	
#deffunc smkkbasedraw
	repeat 10
	grassdraw grassx@.cnt,grassz@.cnt,grassscale@.cnt,grassframe@.cnt
	loop
	
	grassdraw -1.0,-5.0,1.0,0
	;grassdraw -0.5,-5.0,1.1,20
	grassdraw 0.0,-5.0,1.3,20
	;grassdraw 0.5,-5.0,1.2,0
	
	grassdraw 1.0,-5.0,1.1,30
	
	;grassdraw 1.5,-4.5,1.1,0
	grassdraw 2.0,-4.0,1.2,30
	;grassdraw 2.5,-3.5,1.3,0
	grassdraw 3.0,-3.0,1.1,20
	;grassdraw 3.5,-2.5,1.0,0
	grassdraw 4.0,-2.0,1.1,0
	;grassdraw 4.5,-1.5,1.0,10
	grassdraw 5.0,-1.0,1.1,10
	;grassdraw 5.5,-0.5,1.0,0
	
	grassdraw 6.0,0.0,1.3,20
	;grassdraw 6.0,0.5,1.2,40
	grassdraw 6.0,1.0,1.1,0
	;grassdraw 6.0,1.5,1.0,0

	grassdraw 6.0,2.0,1.3,20
	;grassdraw 5.5,2.5,1.1,0
	grassdraw 5.0,3.0,1.0,10
	;grassdraw 4.5,3.5,1.2,30
	grassdraw 4.0,4.0,1.1,40
	;grassdraw 3.5,4.5,1.0,0
	grassdraw 3.0,5.0,1.2,10
	;grassdraw 2.5,5.5,1.3,0
	grassdraw 2.0,6.0,1.1,0

	;grassdraw 2.0,6.0,1.0,30
	grassdraw 1.5,6.0,1.2,20
	;grassdraw 1.0,6.0,1.1,0
	grassdraw 0.5,6.0,1.0,40
	;grassdraw 0.0,6.0,1.3,0
	grassdraw -0.5,6.0,1.1,10
	;grassdraw -1.0,6.0,1.0,20
	grassdraw -1.5,6.0,1.3,0
	;grassdraw -2.0,6.0,1.0,10

	grassdraw -6.0,2.0,1.0,10
	;grassdraw -5.5,2.5,1.1,40
	grassdraw -5.0,3.0,1.0,0
	;grassdraw -4.5,3.5,1.3,30
	grassdraw -4.0,4.0,1.1,0
	;grassdraw -3.5,4.5,1.0,20
	grassdraw -3.0,5.0,1.1,0
	;grassdraw -2.5,5.5,1.2,10
	grassdraw -2.0,6.0,1.0,0

	;grassdraw -6.0,0.0,1.0,40
	grassdraw -6.0,0.5,1.1,0
	;grassdraw -6.0,1.0,1.0,20
	grassdraw -6.0,1.5,1.3,0

	;grassdraw -1.5,-4.5,1.0,40
	grassdraw -2.0,-4.0,1.2,0
	;grassdraw -2.5,-3.5,1.2,10
	grassdraw -3.0,-3.0,1.0,0
	;grassdraw -3.5,-2.5,1.3,20
	grassdraw -4.0,-2.0,1.1,30
	;grassdraw -4.5,-1.5,1.3,0
	grassdraw -5.0,-1.0,1.2,10
	;grassdraw -5.5,-0.5,1.0,0

	;lowtreedraw 11.0,0.0,0.0,0.0
	;lowtreedraw -11.0,0.0,0.0,0.1
	lowtreedraw 9.0,0.0,8.0,0.2
	lowtreedraw -9.0,0.0,8.0,0.3
	lowtreedraw 4.0,0.0,9.0,0.4
	lowtreedraw -4.0,0.0,9.0,0.5
	;lowtreedraw 7.0,0.0,-7.0,0.6
	;lowtreedraw -7.0,0.0,-7.0,0.7
	;lowtreedraw 5.0,0.0,-10.0,0.8
	;lowtreedraw -5.0,0.0,-10.0,0.9
	
	hightreedraw 0.0,0.0,11.0,0.0
	hightreedraw 7.0,0.0,9.0,0.1
	hightreedraw -7.0,0.0,9.0,0.2
	hightreedraw 10.0,0.0,5.0,0.3
	hightreedraw -10.0,0.0,5.0,0.4
	;hightreedraw 9.0,0.0,-5.0,0.5
	;hightreedraw -9.0,0.0,-5.0,0.6
	;hightreedraw 7.0,0.0,-9.0,0.7
	;hightreedraw -7.0,0.0,-9.0,0.8

	flower0draw
	flower1draw

	if rcnt1@ >= 4751{
		trans@ = 0.0,-0.001 - double(rcnt1@ - 4751) * 0.05,0.0
		rotation@ = 0.0,0.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkmarkback@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkmarkback@
		trans@ = 0.0,double(rcnt1@ - 4751) * -0.05,0.0
		rotation@ = 0.0,0.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkmark@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkmark@
	}
	else{
		trans@ = 0.0,-0.001,0.0
		rotation@ = 0.0,0.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkmarkback@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkmarkback@
		trans@ = 0.0,0.0,0.0
		rotation@ = 0.0,0.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkmark@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkmark@
	}
	cfunc64v obj3ddrawnm,objsmkkbase@
	cfunc64v obj3ddrawnm,objsmkkwater@

	return

#deffunc flower0draw
	;trans@ = 1.5,-0.05,-6.0
	;rotation@ = 0.0,0.0,0.0
	;cfunc64v obj3dsclrottrsset,objflower0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	;cfunc64v obj3dframesetba,objflower0@, rcnt@ \ 162
	;cfunc64v obj3ddrawba,objflower0@
	;trans@ = -1.5,-0.05,-6.0
	;rotation@ = 0.0,0.5,0.0
	;cfunc64v obj3dsclrottrsset,objflower0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	;cfunc64v obj3dframesetba,objflower0@, (rcnt@ + 40) \ 162
	;cfunc64v obj3ddrawba,objflower0@
	trans@ = 3.5,-0.05,-5.0
	rotation@ = 0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objflower0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower0@, rcnt@ \ 162
	cfunc64v obj3ddrawba,objflower0@
	trans@ = -3.5,-0.05,-5.0
	rotation@ = 0.0,-0.5,0.0
	cfunc64v obj3dsclrottrsset,objflower0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower0@, (rcnt@ + 20) \ 162
	cfunc64v obj3ddrawba,objflower0@
	
	trans@ = -7.5,-0.05,-0.0
	rotation@ = 0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objflower0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower0@, rcnt@ \ 162
	cfunc64v obj3ddrawba,objflower0@
	trans@ = 7.5,-0.05,0.0
	rotation@ = 0.0,0.5,0.0
	cfunc64v obj3dsclrottrsset,objflower0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower0@, (rcnt@ + 10) \ 162
	cfunc64v obj3ddrawba,objflower0@
	trans@ = -5.0,-0.05,5.0
	rotation@ = 0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objflower0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower0@, rcnt@ \ 162
	cfunc64v obj3ddrawba,objflower0@
	trans@ = 5.0,-0.05,5.0
	rotation@ = 0.0,-0.5,0.0
	cfunc64v obj3dsclrottrsset,objflower0@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower0@, (rcnt@ + 30) \ 162
	cfunc64v obj3ddrawba,objflower0@
	return

#deffunc flower1draw
	trans@ = 5.0,0.0,-4.0
	rotation@ = 0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objflower1@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower1@, rcnt@ \ 162
	cfunc64v obj3ddrawba,objflower1@

	trans@ = -5.0,0.0,-4.0
	rotation@ = 0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objflower1@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower1@, (rcnt@ + 40) \ 162
	cfunc64v obj3ddrawba,objflower1@

	trans@ = 8.0,0.0,-2.0
	rotation@ = 0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objflower1@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower1@, (rcnt@ + 20) \ 162
	cfunc64v obj3ddrawba,objflower1@

	trans@ = -8.0,0.0,-2.0
	rotation@ = 0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objflower1@, varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3dframesetba,objflower1@, (rcnt@ + 30) \ 162
	cfunc64v obj3ddrawba,objflower1@
	return

#deffunc inutakentatelvision
	cfunc64v setscissorrect,varptr64(irect2@)
	cfunc64v viewmatrixset,0.0, 1.2,-3.0,0.0, 1.2, 0.0,upvecx@,upvecy@,upvecz@
	cfunc64v renderstart,50,50,50,1.0
	cfunc64v obj3ddrawba,objinuta@
	cfunc64v obj3ddrawba,objkenta@
	rendersprite texfromrender@,0,0,2.5,1.40625, 0.0,0.0,1.0,1.0, 0,rotrad,rotcx0,rotcy0,0.99999,1.0
	nowbacki@ = cfunc64i(nowgetbackbufferindex)
	cfunc64v copyswapchaintotex,nowbacki@,tex640360a@,varptr64(ipos2@)
	cfunc64v setscissorrect,varptr64(irect0@)
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc tcpartrender
	trans@ = 0.0,1.0,-12.0
	rotation@ = 0.0,M_PI,0.0
	cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
	cfunc64v obj3ddrawnm,objthcpart@	
	if tcpartframe@ >= 60{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 60),0.0,rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	if tcpartframe@ >= 80{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 80) + rad36deg@,rad36deg@,2.0 * rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	if tcpartframe@ >= 100{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 100) + 2.0 * rad36deg@,2.0 * rad36deg@,3.0 * rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	if tcpartframe@ >= 120{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 120) + 3.0 * rad36deg@,3.0 * rad36deg@,4.0 * rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	if tcpartframe@ >= 140{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 140) + 4.0 * rad36deg@,4.0 * rad36deg@,5.0 * rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	if tcpartframe@ >= 160{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 160) + 5.0 * rad36deg@,5.0 * rad36deg@,6.0 * rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	if tcpartframe@ >= 180{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 180) + 6.0 * rad36deg@,6.0 * rad36deg@,7.0 * rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	if tcpartframe@ >= 200{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 200) + 7.0 * rad36deg@,7.0 * rad36deg@,8.0 * rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	if tcpartframe@ >= 220{
		dfanglez = limitf(M_PI / 120.0 * double(tcpartframe@ - 220) + 8.0 * rad36deg@,8.0 * rad36deg@,9.0 * rad36deg@)
		rotation@ = 0.0,M_PI,-dfanglez
		cfunc64v obj3dsclrottrsset,objthcpart@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objthcpart@
	}
	tcpartframe@++
	return

#deffunc ibusyahzdsprtvision
	cfunc64v setscissorrect,varptr64(irect1@)
	cfunc64v viewmatrixset,0.0,1.0,-12.0,-0.5,1.0,-7.0,upvecx@,upvecy@,upvecz@
	cfunc64v renderstart,50,50,50,1.0
	cfunc64v obj3ddrawba,objibusyah@
	cfunc64v obj3ddrawba,1
	setnewframe 1
	smkkbasedraw
	rendersprite texfromrender@,0,0,2.5,1.40625, 0.0,0.0,1.0,1.0, 0,rotrad,rotcx0,rotcy0,0.99999,1.0
	rendersprite texbackmountain@,0,320,1.0,0.6, 0.0,250.0 / 720,1.0,450.0 / 720, 0,rotrad,rotcx0,rotcy0,0.99998,1.0
	nowbacki@ = cfunc64i(nowgetbackbufferindex)
	cfunc64v copyswapchaintotex,nowbacki@,tex512render@,varptr64(ipos1@)
	cfunc64v setscissorrect,varptr64(irect0@)
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc inutakentasmkkvision
	cfunc64v setscissorrect,varptr64(irect1@)
	cfunc64v viewmatrixset,0.0,1.0,6.0,0.0,1.0,10.0,upvecx@,upvecy@,upvecz@
	cfunc64v renderstart,50,50,50,1.0
	cfunc64v obj3ddrawba,objsmkk00@
	cfunc64v obj3ddrawba,objsmkk03@
	cfunc64v obj3ddrawba,objinuta@
	cfunc64v obj3ddrawba,objkenta@
	smkkbasedraw
	rendersprite texfromrender@,0,0,2.5,1.40625, 0.0,0.0,1.0,1.0, 0,rotrad,rotcx0,rotcy0,0.99999,1.0
	nowbacki@ = cfunc64i(nowgetbackbufferindex)
	cfunc64v copyswapchaintotex,nowbacki@,tex512render@,varptr64(ipos1@)
	cfunc64v setscissorrect,varptr64(irect0@)
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@

	smkk00frame@++
	if smkk00frame@ = 124 : smkk00frame@ = 63
	cfunc64v obj3dframesetba,objsmkk00@,smkk00frame@
	smkk03frame@++
	if smkk03frame@ = 124 : smkk03frame@ = 63
	cfunc64v obj3dframesetba,objsmkk03@,smkk03frame@
	return

#deffunc demogetkeyboardcount
	;if demolevel@ = 0{
		;vec0@ = 2.5,9.5,-3.5
		;cfunc64v posfromworldtoscreen,varptr64(vec0@),varptr64(datamouse@),varptr64(demoprojz@)
		;mouse datamouse@.0 + clx0,datamouse@.1 + cly0
		;demolevel@++
	;}
	;if (demolevel@ >= 1)and(demolevel@ <= 180) : demolevel@++
	;if demolevel@ = 181 : setkeyboardcountbyindex VK_LBUTTON,1 : demolevel@++
	;if demolevel@ = 182 : setkeyboardcountbyindex VK_LBUTTON,0 : demolevel@++

	;drawint 600,700,demolevel@
	return

#deffunc labofurnituredraw
		trans@ = -4.8,0.0,0.5
		rotation@ = 0.0,0.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkjikkendai@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objsmkkjikkendai@
		trans@ = -4.8,0.0,3.5
		cfunc64v obj3dsclrottrsset,objsmkkjikkendai@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objsmkkjikkendai@
		trans@ = -4.8,0.0,6.5
		cfunc64v obj3dsclrottrsset,objsmkkjikkendai@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawba,objsmkkjikkendai@

		trans@ = 4.0,0.0,0.5
		rotation@ = 0.0,0.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkdesk@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkdesk@
		trans@ = 4.0,0.0,3.5
		cfunc64v obj3dsclrottrsset,objsmkkdesk@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkdesk@
		trans@ = 4.0,0.0,6.5
		cfunc64v obj3dsclrottrsset,objsmkkdesk@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkdesk@

		trans@ = 3.0,0.053,1.0
		rotation@ = 0.0,0.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkchair@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkchair@
		trans@ = 3.3,0.053,4.2
		rotation@ = 0.0,1.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkchair@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkchair@
		trans@ = 2.7,0.053,6.9
		rotation@ = 0.0,2.0,0.0
		cfunc64v obj3dsclrottrsset,objsmkkchair@,varptr64(scale1@), varptr64(rotation@), varptr64(trans@)
		cfunc64v obj3ddrawnm,objsmkkchair@

		return

#deffunc smkklabovision
	cfunc64v setscissorrect,varptr64(irect1@)
	cfunc64v viewmatrixset,-5.0,1.3,0.0,0.0,1.3,5.0,upvecx@,upvecy@,upvecz@
	cfunc64v renderstart,50,50,50,1.0
	cfunc64v obj3ddrawba,objsmkk00@
	cfunc64v obj3ddrawba,objsmkk03@
	cfunc64v obj3ddrawba,1
	cfunc64v obj3ddrawnm,objcubeshere@
	cfunc64v obj3ddrawba,objsmkklaborouka@
	labofurnituredraw
	cfunc64v obj3ddrawnm,objsmkklaboroom@
	cfunc64v obj3ddrawnm,objtransparent@
	cfunc64v obj3ddrawba,objlabolight@
	nowbacki@ = cfunc64i(nowgetbackbufferindex)
	cfunc64v copyswapchaintotex,nowbacki@,tex512render@,varptr64(ipos1@)
	cfunc64v setscissorrect,varptr64(irect0@)
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@

	smkk00frame@++
	if smkk00frame@ = 124 : smkk00frame@ = 63
	cfunc64v obj3dframesetba,objsmkk00@,smkk00frame@
	smkk03frame@++
	if smkk03frame@ = 124 : smkk03frame@ = 63
	cfunc64v obj3dframesetba,objsmkk03@,smkk03frame@
	setnewframe 1
	return

#global
	ddim grassx,10
	ddim grassz,10
	ddim grassscale,10
	dim grassframe,10
	grassparamset

	rad36deg = 0.62831853
	
	buffer 1,256,256
	gsel 1
	cls 4
	color 255,255,255
	font "lr SVbN",20
	mes "0123456789.-"
	mref vrammsg20white,66

	scwidth = 1280
	scheight = 720
	mydir = dir_cur

	i = cfunc64i(createaudioengine,10)
	myfilename = strw(mydir + "\\MEDIA" + "\\click.wav")
	sndclick = cfunc64i(createseinst,0,varptr64(myfilename))
	myfilename = strw(mydir + "\\MEDIA" + "\\charajump.wav")
	sndcharajump = cfunc64i(createseinst,1,varptr64(myfilename))
	myfilename = strw(mydir + "\\MEDIA" + "\\charawalk.wav")
	sndcharawalk = cfunc64i(createseinst,2,varptr64(myfilename))
	myfilename = strw(mydir + "\\MEDIA" + "\\playstart.wav")
	sndplaystart = cfunc64i(createseinst,3,varptr64(myfilename))
	myfilename = strw(mydir + "\\MEDIA" + "\\stageback.wav")
	sndstageback = cfunc64i(createseinst,4,varptr64(myfilename))
	seinstsetvolume sndstageback,0.5
	myfilename = strw(mydir + "\\MEDIA" + "\\blkmove.wav")
	sndblkmove = cfunc64i(createseinst,5,varptr64(myfilename))
	seinstsetvolume sndblkmove,0.5
	myfilename = strw(mydir + "\\MEDIA" + "\\goal.wav")
	sndgoal = cfunc64i(createseinst,6,varptr64(myfilename))
	myfilename = strw(mydir + "\\MEDIA" + "\\opening.wav")
	sndopening = cfunc64i(createseinst,7,varptr64(myfilename))

	
	swdim adaptername,512,1

	screen 0,scwidth / 2,scheight / 2,0,0,0
	pos 0,0
	mes "A_v^[I"
	nadapters = cfunc64i(createadapter,varptr64(adaptername) )
	mes "A_v^[: " + str(nadapters)
	jadapter = 0
	selectadaptername = str(adaptername)
	strrep selectadaptername,";","\n"
	objsize 300,24
	combox jadapter,100,selectadaptername
	button goto "̃A_v^[ŃQ[",*Selectend  
	stop
	
*Selectend
	screen 0,scwidth,scheight,0,0,0
	title "ZJCL[̒npY(meetƌ)"
	i = -1
	i = cfunc64i(createdevice,hwnd,jadapter,scwidth,scheight,500)

	dim datamouse,2
	ddim nearzworld,3
	ddim farzworld,3
	ddim vec0,3
	ddim vec1,3
	ddim vec2,3
	demoprojz = 1.0
	
	dim campos,3
	dim camtargetpos,3
	dim camvec,3
	cameradegstep = 10.0 / 360.0 * M_PI
	camerastep = 0.1
	camvec = 0.0, 0.0, 0.0
	
	fovangle = 0.785
	aspectratio = double(scwidth) / double(scheight)
	nearz = 1.0
	farz = 50.0

	rotrad = 0.0
	rotcx0 = 0
	rotcy0 = 0
	projz = 0.0

	ddim scale,3
	ddim scale1,3
	ddim rotation,3
	ddim trans,3
	scale1 = 1.0,1.0,1.0
	rotation = 0.0,0.0,0.0
	ddim charapos,3,4
	ddim charadir,3,4
	dim charamotion,4
	dim charaframe,4

	myfilename = strw(mydir + "\\MEDIA" + "\\ibusyah2d.txt")
	i = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.18)
	cfunc64v obj3dbrendmodeset,0, 0, 1.0
	trans = 2.0,0.0,-3.0
	cfunc64v obj3dsclrottrsset,0, varptr64(scale1), varptr64(rotation), varptr64(trans)
	cfunc64v obj3dframesetba,0, 1

	myfilename = strw(mydir + "\\MEDIA" + "\\zodoseprt.txt")
	i = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.18)
	cfunc64v obj3dbrendmodeset,1, 0, 1.0
	trans = 4.0,0.0,-3.0
	cfunc64v obj3dsclrottrsset,1, varptr64(scale1), varptr64(rotation), varptr64(trans)
	cfunc64v obj3dframesetba,1, 1

	myfilename = strw(mydir + "\\MEDIA" + "\\smkk002d.txt")
	i = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.2)
	cfunc64v obj3dbrendmodeset,2, 0, 1.0
	trans = 6.0,0.0,-3.0
	cfunc64v obj3dsclrottrsset,2, varptr64(scale1), varptr64(rotation), varptr64(trans)
	cfunc64v obj3dframesetba,2, 1
	
	myfilename = strw(mydir + "\\MEDIA" + "\\smkk032d.txt")
	i = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.18)
	cfunc64v obj3dbrendmodeset,3, 0, 1.0
	trans = 8.0,0.0,-3.0
	cfunc64v obj3dsclrottrsset,3, varptr64(scale1), varptr64(rotation), varptr64(trans)
	cfunc64v obj3dframesetba,3, 1

	trans = 0.0,0.0,0.0
	myfilename = strw(mydir + "\\MEDIA" + "\\s1northwall.txt")
	objs1nwall = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objs1nwall, 0, 1.0
	cfunc64v obj3dsclrottrsset,objs1nwall, varptr64(scale1), varptr64(rotation), varptr64(trans)
	tex512render = cfunc64i(getobj3dtexno,objs1nwall,0,0)

	myfilename = strw(mydir + "\\MEDIA" + "\\s1eastwall.txt")
	objs1ewall = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objs1ewall, 0, 1.0
	cfunc64v obj3dsclrottrsset,objs1ewall, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\s1southwall.txt")
	objs1swall = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objs1swall, 0, 1.0
	cfunc64v obj3dsclrottrsset,objs1swall, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\s1westwall.txt")
	objs1wwall = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objs1wwall, 0, 1.0
	cfunc64v obj3dsclrottrsset,objs1wwall, varptr64(scale1), varptr64(rotation), varptr64(trans)

	texfromrender = cfunc64i(createcolortexture,512,512,0,0,0,255)
	cfunc64v obj3dtexchange,objs1nwall,0,0,texfromrender
	cfunc64v obj3dtexchange,objs1ewall,0,0,texfromrender
	cfunc64v obj3dtexchange,objs1swall,0,0,texfromrender
	cfunc64v obj3dtexchange,objs1wwall,0,0,texfromrender
	
	myfilename = strw(mydir + "\\MEDIA" + "\\gear1.txt")
	objgear = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),1.0)
	cfunc64v obj3dbrendmodeset,objgear, 0, 1.0
	cfunc64v obj3dframesetba,objgear, 1

	myfilename = strw(mydir + "\\MEDIA" + "\\walllight.txt")
	objwalllight = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objwalllight, 1, 1.0
	texa = cfunc64i(getobj3dtexno,objwalllight,0,0)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\plane0.txt")
	objlightpart = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objlightpart, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\plane1.txt")
	objgearpart = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objgearpart, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\wallhigh.txt")
	objwallhigh = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objwallhigh, 0, 1.0
	trans = 0.0,10.0,0.0
	cfunc64v obj3dsclrottrsset,objwallhigh, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\entrance.txt")
	objentrance = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objentrance, 0, 1.0
	trans = 4.0,10.0,0.0
	cfunc64v obj3dsclrottrsset,objentrance, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\exit.txt")
	objexit = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objexit, 0, 1.0
	rotation = 0.0,-0.5 * M_PI,0.0
	trans = 0.0,1.0,-7.0
	cfunc64v obj3dsclrottrsset,objexit, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\walllow.txt")
	objwalllow = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objwalllow, 0, 1.0
	rotation = 0.0,0.0,0.0
	trans = 0.0,-5.0,0.0
	cfunc64v obj3dsclrottrsset,objwalllow, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\cubeleaf.txt")
	objcubeleaf = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubeleaf, 0, 1.0
	texleaf = cfunc64i(getobj3dtexno,objcubeleaf,0,0)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\cubetree.txt")
	objcubetree = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubetree, 0, 1.0
	textreebark = cfunc64i(getobj3dtexno,objcubetree,0,0)
	texnenrin = cfunc64i(getobj3dtexno,objcubetree,1,0)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\cubesand.txt")
	objcubesand = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubesand, 0, 1.0
	texsand = cfunc64i(getobj3dtexno,objcubesand,0,0)

	myfilename = strw(mydir + "\\MEDIA" + "\\cuberock.txt")
	objcuberock = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcuberock, 0, 1.0
	texrock = cfunc64i(getobj3dtexno,objcuberock,0,0)

	myfilename = strw(mydir + "\\MEDIA" + "\\cubefix.txt")
	objcubefix = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubefix, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\cubeadsorp.txt")
	objcubeadsorp = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubeadsorp, 0, 1.0
	texupdown = cfunc64i(getobj3dtexno,objcubeadsorp,0,0)
	texmawari = cfunc64i(getobj3dtexno,objcubeadsorp,1,0)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\cubearrowleaf.txt")
	objcubearrowleaf = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubearrowleaf, 0, 1.0
	
	myfilename = strw(mydir + "\\MEDIA" + "\\cubearrowtree.txt")
	objcubearrowtree = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubearrowtree, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\cubearrowsand.txt")
	objcubearrowsand = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubearrowsand, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\cubearrowrock.txt")
	objcubearrowrock = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubearrowrock, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\blklight.txt")
	objblklight = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objblklight, 1, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\selectring.txt")
	objselectring = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objselectring, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\sankakusui.txt")
	objselectchara = cfunc64i(readbatextfilemakeobj3d,strw(myfilename),0.4)	
	cfunc64v obj3dbrendmodeset,objselectchara, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\yellowlight.txt")
	objyellowlight = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objyellowlight, 1, 1.0
	rotation = 0.0,0.0,0.0
	trans = 3.5,10.0,-3.5
	cfunc64v obj3dsclrottrsset,objyellowlight, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\cubegoal.txt")
	objcubegoal = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)	
	cfunc64v obj3dbrendmodeset,objcubegoal, 0, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\rock0.txt")
	objrock0 = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),2.0)	
	cfunc64v obj3dbrendmodeset,objrock0, 0, 1.0
	trans = 0.0,-0.1,0.0
	cfunc64v obj3dsclrottrsset,objrock0, varptr64(scale1), varptr64(rotation), varptr64(trans)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\water.txt")
	objwater = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),2.0)	
	cfunc64v obj3dbrendmodeset,objwater, 0, 1.0
	trans = 0.0,0.0,0.0
	cfunc64v obj3dsclrottrsset,objwater, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\semekaikiibase.txt")
	objsmkkbase = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\semekaikiimark.txt")
	objsmkkmark = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)
	cfunc64v obj3dbrendmodeset,objsmkkmark, 1, 1.0
	
	myfilename = strw(mydir + "\\MEDIA" + "\\semekaikiimarkback.txt")
	objsmkkmarkback = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)
	trans = 0.0,-0.001,0.0
	cfunc64v obj3dsclrottrsset,objsmkkmarkback, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\smkkbasewater.txt")
	objsmkkwater = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)
	trans = 0.0,-0.001,0.0
	cfunc64v obj3dsclrottrsset,objsmkkwater, varptr64(scale1), varptr64(rotation), varptr64(trans)

	myfilename = strw(mydir + "\\MEDIA" + "\\trunk0.txt")
	objtrunk0 = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\branch.txt")
	objbranch = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\branch2a5.txt")
	objbranch2a = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\branch2a3.txt")
	objbranch2b = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\branch2a2.txt")
	objbranch2c = cfunc64i(readnmtextfilemakeobj3d,strw(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\grass.txt")
	objgrass = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.2)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\flower0.txt")
	objflower0 = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\flower1.txt")
	objflower1 = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.5)

	myfilename = strw(mydir + "\\MEDIA" + "\\inuta.txt")
	objinuta = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.133)

	myfilename = strw(mydir + "\\MEDIA" + "\\kenta.txt")
	objkenta = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.133)

	myfilename = strw(mydir + "\\MEDIA" + "\\ibusyah.txt")
	objibusyah = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.174)

	myfilename = strw(mydir + "\\MEDIA" + "\\thcpart.txt")
	objthcpart = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),1.0)
	cfunc64v obj3dtexchange,objthcpart,1,0,tex512render
	
	myfilename = strw(mydir + "\\MEDIA" + "\\thchannelb.txt")
	objthchannelb = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),1.0)
	cfunc64v obj3dtexchange,objthchannelb,1,0,tex512render
	ddim tcmatparam,11
	tcmatparam(0) = 0.0
	tcmatparam(1) = 1.0
	tcmatparam(2) = 1.0
	tcmatparam(3) = 1.0
	tcmatparam(4) = 100.0010
	tcmatparam(5) = 1.0
	tcmatparam(6) = 1.0
	tcmatparam(7) = 1.0
	tcmatparam(8) = 0.08
	tcmatparam(9) = 0.08
	tcmatparam(10) = 0.08

	myfilename = strw(mydir + "\\MEDIA" + "\\smkk00.txt")
	objsmkk00 = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.16)

	myfilename = strw(mydir + "\\MEDIA" + "\\smkk03.txt")
	objsmkk03 = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.125)

	myfilename = strw(mydir + "\\MEDIA" + "\\thchannelc.txt")
	objthchannelc = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),1.0)
	cfunc64v obj3dtexchange,objthchannelc,1,0,tex512render

	myfilename = strw(mydir + "\\MEDIA" + "\\seachlight.txt")
	objseachlight = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),1.0)
	cfunc64v obj3dbrendmodeset,objseachlight, 1, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\cubeshere.txt")
	objcubeshere = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),0.1)
	
	myfilename = strw(mydir + "\\MEDIA" + "\\smkklaborouka.txt")
	objsmkklaborouka = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\smkklaboroom.txt")
	objsmkklaboroom = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\jikkendai.txt")
	objsmkkjikkendai = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\desk.txt")
	objsmkkdesk = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\chair.txt")
	objsmkkchair = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\labotransparent.txt")
	objtransparent = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),1.0)
	cfunc64v obj3dbrendmodeset,objtransparent, 3, 0.3

	myfilename = strw(mydir + "\\MEDIA" + "\\labolight.txt")
	objlabolight = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),1.0)
	cfunc64v obj3dbrendmodeset,objlabolight, 1, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\monomanemant.txt")
	objmonomane = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),1.0)
	cfunc64v obj3dtexchange,objmonomane,0,0,tex512render

	myfilename = strw(mydir + "\\MEDIA" + "\\semekaikii.txt")
	objsemekaikii = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),1.0)

	myfilename = strw(mydir + "\\MEDIA" + "\\cubesherelight.txt")
	objcubesherelight = cfunc64i(readnmtextfilemakeobj3d,varptr64(myfilename),0.1)
	cfunc64v obj3dbrendmodeset,objcubesherelight, 1, 1.0

	myfilename = strw(mydir + "\\MEDIA" + "\\smkk00b.txt")
	objsmkk00b = cfunc64i(readbatextfilemakeobj3d,varptr64(myfilename),0.16)
	
	dim irect0,4
	dim irect1,4
	dim irect2,4
	dim irect3,4
	dim irect4,4
	dim ipos1,2
	dim ipos2,2
	dim ipos3,2
	dim ipos4,2
	ipos1 = 384,104
	ipos2 = 320,180
	ipos3 = 576,296
	ipos4 = 512,232
	irect0 = 0,0,scwidth,scheight
	irect1 = 384,104,512,512
	irect2 = 320,180,scwidth / 2,scheight / 2
	irect3 = 576,296,128,128
	irect4 = 512,232,256,256
	
	mojitexmsg20white = cfunc64i(createcolortexture,256,256,200,100,150,255)
	cfunc64v textransfer8888,mojitexmsg20white,varptr64(vrammsg20white),256

	myfilename = strw(mydir + "\\MEDIA" + "\\blank640360.png")
	tex640360a = cfunc64i(createsrvfromfile,varptr64(myfilename))
	tex640360b = cfunc64i(createsrvfromfile,varptr64(myfilename))
	tex640360c = cfunc64i(createsrvfromfile,varptr64(myfilename))
	tex640360d = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\processmoji.png")
	texmojiprocess = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\mojiback.png")
	texmojiback = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\rotationtex.png")
	texrotcircle = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\rotationtex1.png")
	texrotcircle1 = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\stagestartmoji.png")
	texstagestartmoji = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\texwallb1.jpg")
	texwallb1 = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\texwallb4.jpg")
	texwallb2 = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\backmountain1.png")
	texbackmountain = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\title1.png")
	textitle = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\titleselect.png")
	textitleselect = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\chara4040tp.bmp")
	texchara4040 = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\sinario0.bmp")
	texsinarioleftup = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\projyoko.bmp")
	texprojyoko = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\projwaku.png")
	texprojwaku = cfunc64i(createsrvfromfile,varptr64(myfilename))

	;myfilename = strw(mydir + "\\MEDIA" + "\\demotexleft.bmp")
	;texdemoleft = cfunc64i(createsrvfromfile,varptr64(myfilename))

	;myfilename = strw(mydir + "\\MEDIA" + "\\demotexright.bmp")
	;texdemoright = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\eetto.png")
	texeetto = cfunc64i(createsrvfromfile,varptr64(myfilename))

	myfilename = strw(mydir + "\\MEDIA" + "\\tudukumoji.png")
	textudukumoji = cfunc64i(createsrvfromfile,varptr64(myfilename))
	
	ddim matparamwalllight,11
	matparamwalllight(0) = 1.0
	matparamwalllight(1) = 1.0
	matparamwalllight(2) = 1.0
	matparamwalllight(3) = 1.0
	matparamwalllight(4) = 7.5
	matparamwalllight(5) = 1.0
	matparamwalllight(6) = 1.0
	matparamwalllight(7) = 1.0
	matparamwalllight(8) = 0.1
	matparamwalllight(9) = 0.1
	matparamwalllight(10) = 0.1
	
	ddim matparam,11
	matparam(0) = 0.0
	matparam(1) = 0.0
	matparam(2) = 0.0
	matparam(3) = 0.0
	matparam(4) = 0.0
	matparam(5) = 0.0
	matparam(6) = 0.0
	matparam(7) = 0.0
	matparam(8) = 0.0
	matparam(9) = 0.0
	matparam(10) = 0.0
	cfunc64v obj3dmatset,objwater,20,varptr64(matparam)
	mattextransfer objwater
	cfunc64v obj3dmatset,objsmkkwater,20,varptr64(matparam)
	mattextransfer objsmkkwater

	dim spaceijk,10,10,10
	sdim a,2048
	notesel a
	sdim forloadstr,5,30
	sdim fileline,128
	dim blksnum,6
	dim blksposi,6,97
	dim blksposj,6,97
	dim blksposk,6,97
	dim blksvalue,6,97
	dim jblk,6
	dim walkmatrix,10,10
	dim lclickmatrix,10,10
	dim charaonblks,4
	dim blkundercharas,5
	dim process,2000
	dim screenplace,4

	dim clearstep,9
	noteload "stageclearstate.txt"
	repeat 9
	noteget fileline,cnt
	split fileline,";",forloadstr
	clearstep(cnt) = int(forloadstr(1))
	loop

	dim tex256select,9
	repeat 9
	tex256select(cnt) = cfunc64i(createcolortexture,256,256,200,100,150,255)
	loop
	
